/// <reference types="react" />
import * as React from 'react';
import { FieldsProp } from 'redux-forms/lib/shared/fieldArrayProps';
import { ContextProps } from './connectField';
export declare type SuppliedProps = {
    name?: string;
    fields: FieldsProp;
};
export declare type FieldArrayProps<T> = T & {
    name: string;
    component: React.ComponentClass<T & SuppliedProps> | React.SFC<T & SuppliedProps>;
    withRef?: (el: React.ReactElement<any>) => void;
};
declare const Contexted: React.StatelessComponent<{} & {
    name: string;
    component: React.ComponentClass<{} & SuppliedProps> | React.StatelessComponent<{} & SuppliedProps>;
    withRef?: ((el: React.ReactElement<any>) => void) | undefined;
} & {
    name: string;
}> & {
    WrappedComponent?: React.ComponentClass<{} & {
        name: string;
        component: React.ComponentClass<{} & SuppliedProps> | React.StatelessComponent<{} & SuppliedProps>;
        withRef?: ((el: React.ReactElement<any>) => void) | undefined;
    } & {
        name: string;
    } & ContextProps> | undefined;
};
export default Contexted;
