/// <reference types="react" />
import * as React from 'react';
export declare type FormProps = {
    name: string;
};
export declare type ContextProps = {
    _form: string;
};
export declare type WrappedField<T> = React.ComponentClass<T & FormProps & ContextProps>;
export declare type Connected<T> = React.SFC<T & FormProps> & {
    WrappedComponent?: WrappedField<T>;
};
export default function connectField<T>(Wrapped: WrappedField<T>): Connected<T>;
